camera = {}

function camera:new (o)
      o = o or {}   -- create object if user does not provide one
      setmetatable(o, self)
      self.__index = self
      return o
end

function camera:initialize()
	self.centerX = 0
	self.centerY = 0
	self.xTrans = 0
	self.yTrans = 0
	camera.width = global.screenW
	camera.height = global.screenH
end

function camera:setCenter()
	self.centerX = global.activeSprite:centerX()
	self.centerY = global.activeSprite:centerY()
end

function camera:prep()
	self.xTrans = self.centerX - (global.screenW/2) / (global.scale)
	self.yTrans = self.centerY - (global.screenH/2) / (global.scale)
	love.graphics.push() -- stores the default coordinate system
	love.graphics.scale(global.scale, global.scale)
	love.graphics.translate(-self.xTrans, -self.yTrans)--adds values to x and y (subtracts, here, because adding negative) -- basically, sets top-left corner of camera
	--[[	self.framebuffer = love.graphics.newFramebuffer(global.screenW, global.screenH - global.topUI - global.bottomUI)
	love.graphics.setRenderTarget(self.framebuffer)

--]]
end

function camera:done()
	love.graphics.pop() -- return to the default coordinates; unsets scale and translate
--[[	love.graphics.setRenderTarget()--return to default render target
	love.graphics.draw(self.framebuffer, global.cameraLeftOffset,global.cameraTopOffset)
--]]
end

function camera:relMouseX()
	local x = global.mouseX
	if x > global.screenW / 2 then
		x = self.centerX + (x - (global.screenW / 2))
	else
		x = self.centerX - ((global.screenW /2) - x)
	end
	return x
end

function camera:relMouseY()
	local y = global.mouseY
	if y > global.screenH / 2 then
		y = self.centerY + (y - (global.screenH / 2))
	else
		y = self.centerY - ((global.screenH /2) - y)
	end
	return y
end