tile = {}

function tile:animate()
    self.counter = self.counter + global.timeValue
	if self.counter > (10/global.speed) then
		self:incrementFrame()
		self.counter = 0
	end
end

function tile:incrementFrame()
	if self.frame >= self.maxFrame then
		self.frame = 1
	else
		self.frame = self.frame + 1
	end
end

function tile:moveLeft()
	self.x = self.x - (global.speed * global.timeValue)
	self:animate()
end

function tile:moveRight()
	self.x = self.x + (global.speed * global.timeValue)
	self:animate()
end

function tile:moveDown()
	self.y = self.y + (global.speed * global.timeValue)
	self:animate()
end

function tile:moveUp()
	self.y = self.y - (global.speed * global.timeValue)
	self:animate()
end

function tile:draw()
		love.graphics.drawq(global.spriteHolder[self.spriteKey].sheet, global.spriteHolder[self.spriteKey][self.face][self.frame], self.x, self.y)
end

function tile:new (o)
      o = o or {}   -- create object if user does not provide one
      setmetatable(o, self)
      self.__index = self
      return o
end

function tile:initialize(img)
	local theQuad
	local default = {}
	local width
	local height
	if global.spriteHolder[img] == nil then
		self.spriteKey = img
		global.spriteHolder[img] = {}
		global.spriteHolder[img]['default'] = {}
		global.spriteHolder[img].sheet = love.graphics.newImage(img)
		width = global.spriteHolder[img].sheet:getWidth()
		height = global.spriteHolder[img].sheet:getHeight()
		theQuad = love.graphics.newQuad(0, 0, width, height, width, height)
		table.insert(default, theQuad)
		global.spriteHolder[img]['default'] = default
		global.spriteHolder[img].maxFrame = 1
	else
		self.spriteKey = img
		width = global.spriteHolder[self.spriteKey].sheet:getWidth()
		height = global.spriteHolder[self.spriteKey].sheet:getHeight()
	end
	self.maxFrame = global.spriteHolder[self.spriteKey].maxFrame
	self.face = 'default'
	self.counter = 0
	self.frame = 1
	self.x = 0
	self.y = 0
	self.width = width
	self.height = height
	self.onScreen = false
	self.solid = false
	default = nil
end